// -------------------------------------------------------------
// {[tHO
// 
// Copyright (c) 2003 IMAGIRE Takashi. All rights reserved.
// -------------------------------------------------------------

// -------------------------------------------------------------
// O[oϐ
// -------------------------------------------------------------
float4x4 mWVP;		// [JˉeԂւ̍Wϊ
float4   vCol;		// bV̐F

// -------------------------------------------------------------
// eNX`
// -------------------------------------------------------------
texture DecaleMap;
sampler DecaleMapSamp = sampler_state
{
    Texture = <DecaleMap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
};


// -------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// -------------------------------------------------------------
struct VS_OUTPUT
{
	float4 Pos		: POSITION;
	float4 Col		: COLOR0;
	float2 Tex		: TEXCOORD0;
	float2 Depth	: TEXCOORD1;
	float4 Normal	: TEXCOORD2;
};

// -------------------------------------------------------------
// _VF[_vO
// -------------------------------------------------------------
VS_OUTPUT VS (
	  float4 Pos	: POSITION          // _ʒu
	, float3 Normal	: NORMAL			// @xNg
	, float2 Tex	: TEXCOORD0			// eNX`W
){
	VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
	
	// Wϊ
	float4 pos = mul( Pos, mWVP );
	
	// ʒuW
	Out.Pos = pos;
	
	// ƖvZ
	Out.Col = vCol;
	
	// eNX`W
	Out.Tex = Tex;
	
	// [x
	Out.Depth = 1.0f-pos.z / pos.w;
	
	// @
	Out.Normal.xyz = Normal;
	
	return Out;
}
// -------------------------------------------------------------
// sNZVF[_o̓f[^
// -------------------------------------------------------------
struct PS_OUTPUT {
	float4 Color  : COLOR0;
	float4 Depth  : COLOR1;
	float4 Normal : COLOR2;
};
// -------------------------------------------------------------
// sNZVF[_vO
// -------------------------------------------------------------
PS_OUTPUT PS ( VS_OUTPUT In ) {
	
	PS_OUTPUT Out = ( PS_OUTPUT ) 0;
	
	// ʏF
	Out.Color = In.Col * tex2D( DecaleMapSamp, In.Tex );
	
	// [x
	Out.Depth = In.Depth.x;

	Out.Normal = 0.5f*normalize(In.Normal) + 0.5f;
	
    return Out;
}

// -------------------------------------------------------------
// _VF[_vO
// -------------------------------------------------------------
VS_OUTPUT VS_NoTex (
	  float4 Pos	: POSITION          // _ʒu
	, float3 Normal	: NORMAL			// @xNg
){
	VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
	
	// Wϊ
	float4 pos = mul( Pos, mWVP );
	
	// ʒuW
	Out.Pos = pos;
	
	// ƖvZ
	Out.Col = vCol;
	
	// [x
	Out.Depth = 1.0f-pos.z / pos.w;
	
	// @
	Out.Normal.xyz = Normal;
	
	return Out;
}
// -------------------------------------------------------------
// sNZVF[_vO
// -------------------------------------------------------------
PS_OUTPUT PS_NoTex ( VS_OUTPUT In ) {
	
	PS_OUTPUT Out = ( PS_OUTPUT ) 0;
	
	// ʏF
	Out.Color = In.Col;
	
	// [x
	Out.Depth = In.Depth.x;

	Out.Normal = 0.5f*normalize(In.Normal) + 0.5f;
	
    return Out;
}

// -------------------------------------------------------------
// eNjbN
// -------------------------------------------------------------
technique TShader
{
    pass P0
    {
        // VF[_
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_2_0 PS();

		Sampler[0] = (DecaleMapSamp);
    }
    pass P0
    {
        // VF[_
        VertexShader = compile vs_1_1 VS_NoTex();
        PixelShader  = compile ps_2_0 PS_NoTex();
    }
}
